{ATTENTION ! ATTENTION !ATTENTION !ATTENTION !ATTENTION !ATTENTION !
When using Bray's terminal you HAVE TO download EVERY programversion to EEPROM
opening the comport of Brays Terminal connected to IO-PINS 31,30
causes a RESET of the propeller
and this will OVERWRITE the content of the RAM by the content of the EEPROM
so the ONLY WAY to get a NEW programversion running is to STORE IT TO THE EEPROM !!!   
}


{ ENCORE ROUTER CONTROL V1.0 }
                           
OBJ
  Debug : "FullDuplexSerial" 
  Data  :  "Extended_FDSerial_128ByteBuffers"
  heart : "heartbeat"     'object that makes an LED blink for showing propeller-chip is alive and working
  
Var
  'ATTENTION !!!
  'to avoid datacrashing you have to use the value of the constant MaxStrLength
  'of the object Extended_FDSerial_128ByteBuffers !
  'For the bytearrays that are used for received strings. 
  'The value of this constant can be accessed by writing objectname#constantname 
  Byte  MyStr[Data#MaxStrLength]
 


CON    
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
PUB Start
  Debug.Start(31,30,0,9600)
  debug.str(string("Debug.Start(31,30,0,9600) done",13))
  
  'Data.Start(26,25,2,9600)
  Data.Start(26,25,0,9600)
  debug.str(string("Data.Start(26,25,2,9600) done",13))

  Data.SetDelimiter(04)
  debug.str(string("Data.SetDelimiter(04) done",13))

  heart.Start(9,250) 'blinking on PIN 0 as Lifesignal of PropellerChip
  debug.str(string("heart.Start(9,250) done",13))

  debug.str(string("Start sending Requestcode",13))

  'testing sending and receiving a string
  repeat                                                          'repeat this every 2 seconds
    MyStr[0] := 0  
 
    debug.str(string("direct before call GetSource(31)",13))
    GetSource(31)                                           
    debug.str(string("direct after call GetSource(31)",13))

    Debug.str(string("string received written next line between < and >",13))
    Debug.str(string("<"))
    Debug.str(@mystr)
    Debug.str(string(">"))
    Debug.tx(13)
    Debug.tx(13)


PUB GetSource(dst) : src | cksm, dst_1, dst_2, dst_3, dst_4

  dst := dst - 1                                                   

  dst <<= 4 << 2                                                    'Start Calculating Checksum

  dst_1 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))         
  dst_2 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))
  dst_3 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))
  dst_4 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))                                                                  

  cksm := (-1*((290 + dst_1 + dst_2 + dst_3 + dst_4)//256))+256 
  
  Data.tx(06)                                                       'Send command to get data back
  Data.tx(01)
  Data.tx(78)
  Data.tx(48)
  Data.tx(81)
  Data.tx(74)
  Data.tx(09)
  Data.hex(dst,4)
  Data.hex(cksm,2)
  Data.tx(04)
  
  Data.rxflush                                                      'Data.rxFlush
  Data.rxstr(@mystr)                                       'Store string from equipment
  Data.tx(06)

{the codelines below are Scripting-code for Brays Terminal
program TestSendingAString;

const STRING1 = 'first test';
const SensorAnswerTemplate = 'mmmbsdddddbuuuuu';

const SensorAnswerExample = 'FF1A -123.4 uuuuu';
const RQAnswer = 'Brays Terminal answers ';


var 
  i     : longint;

begin
    while not(i=27) do // repeat until ESC
    begin
      delay(96);
      writeln('send Sensorstring to Propeller ');
      writeln(RQAnswer);
      ComSendmacro('$06$01$4E$30$4A$51$09$30$30$30$30$09$30$31$09$4E$09$4E$09$30$30$31$46$09$30$30$30$30$30$30$30$33$09$09$09$37$46$04');
    end;
end.
}
  